Use [FIM.DEEWRArchive]
Go
Create Table Results (
	Results_Id uniqueidentifier PRIMARY KEY NOT NULL,
	Filter varchar(100) NULL,
	Objects varchar(100) NULL
)
Go
Create Table ExportObject (
	ExportObject_Id uniqueidentifier PRIMARY KEY NOT NULL,
	Source varchar(100) NULL,
	Results_Id uniqueidentifier FOREIGN KEY REFERENCES Results(Results_Id) NOT NULL
)
Go
Create Table ResourceManagementObject (
	ResourceManagementObject_Id uniqueidentifier PRIMARY KEY NOT NULL,
	ObjectIdentifier char(45) NOT NULL,
	ObjectType varchar(20) NOT NULL,
	IsPlaceholder varchar(5) NOT NULL,
	LocalizedResourceManagementAttributes varchar(1) NULL,
	ExportObject_Id uniqueidentifier FOREIGN KEY REFERENCES ExportObject(ExportObject_Id) NOT NULL
)
Go
Create Table ResourceManagementAttributes (
	ResourceManagementAttributes_Id uniqueidentifier PRIMARY KEY NOT NULL,
	ResourceManagementObject_Id uniqueidentifier FOREIGN KEY REFERENCES ResourceManagementObject(ResourceManagementObject_Id) NOT NULL
)
Go
Create Table ResourceManagementAttribute (
	ResourceManagementAttribute_Id uniqueidentifier PRIMARY KEY NOT NULL,
	AttributeName varchar(100) NOT NULL,
	HasReference varchar(5) NOT NULL,
	IsMultiValue varchar(5) NOT NULL,
	Value varchar(800) NULL,
	ResourceManagementAttributes_Id uniqueidentifier FOREIGN KEY REFERENCES ResourceManagementAttributes(ResourceManagementAttributes_Id) NOT NULL
)
Go
Create Table [Values] (
	Values_Id uniqueidentifier PRIMARY KEY NOT NULL,
	ResourceManagementAttribute_Id uniqueidentifier FOREIGN KEY REFERENCES ResourceManagementAttribute(ResourceManagementAttribute_Id) NOT NULL
)
Go
Create Table string (
	string_Text varchar(800) NULL,
	Values_Id uniqueidentifier FOREIGN KEY REFERENCES [Values](Values_Id) NOT NULL
)
Go
Create Table RequestParameter (
	type varchar(50) NOT NULL,
	Target uniqueidentifier NOT NULL,
	Calculated varchar(5) NOT NULL,
	PropertyName varchar(50) NOT NULL,
	Value varchar(800) NULL,
	ResourceManagementAttribute_Id uniqueidentifier FOREIGN KEY REFERENCES ResourceManagementAttribute(ResourceManagementAttribute_Id) NOT NULL
)
Go
